<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.timesheet.inc.php 0.15.1 2005/09/30 C K Wu

    class timesheet {

//---- Timesheet List SQL Formation

    function timesheet_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	if (!$order) {$order = "name,year,week" ; }
	if (!$sort)  {$sort = "ASC" ; }
	$sql =	"SELECT name,year,week,hour_ttl,day_ttl,approved_by,a.id " ;
	$sql.=	"FROM ${pre}timesheet a, ${pre}employee b  ";
	$sql.=	"WHERE 1=1 $where and empid=b.id ORDER BY ".$order." ".$sort ;
	return $sql ;
	}

//---- Timesheet Read

    function timesheet_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$sql = "SELECT a.* FROM ${pre}timesheet a,${pre}employee b " ;
	$sql.= "WHERE a.id='$id' and empid=b.id";
	$result = $adodb->query($sql);
	$dt = $result->fetchRow() ;
	if ($ckapi[params_post][op]<>'view')	$dt[approved_by] = exapi_lang("HR staff") ;

	$sql = "SELECT a.*,b.* FROM ${pre}ts_trans a, ${pre}timesheet b " ;
	$sql.= "WHERE trans_id='$id' and a.trans_id=b.id ORDER BY a.id";
	$result = $adodb->query($sql);
	$dt[tsyear0] = date("Y") ;
	$dt[tsmonth0] = date("m") ;
	$dt[tsday0] = date("d") ;
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$transdate		=	$rs['transdate'] ;
		$dt['tsyear'.$i]	=	substr($transdate,0,4) ;
		$dt['tsmonth'.$i]	=	substr($transdate,5,2) ;
		$dt['tsday'.$i]		=	substr($transdate,8,2) ;
		$dt['project'.$i]	=	$rs['project'] ;
		$dt['activity'.$i]	=	$rs['activity'] ;
		$dt['hour'.$i]		=	$rs['hour'] ;
		$dt['day'.$i]		=	$rs['day'] ;
		$dt['achieve'.$i]	=	$rs['achieve'] ;
		$dt['achival'.$i]	=	$rs['achival'] ;
		$dt['achiunit'.$i]	=	$rs['achiunit'] ;
		}
	return $dt ;
	}

//---- Timesheet Add Initialisation

    function timesheet_add_init() {
	global $ckapi ;

	$ckapi[params_post][dt][approved_by] = exapi_lang("HR staff") ;
	$ckapi[params_post][dt][year] = date("Y") ;
	$ckapi[params_post][dt][week] = date("W",mktime(0,0,0,date("m"),date("d"),date("Y"))) ;
	$ckapi[params_post][dt][tsyear0] = $ckapi[params_post][dt][tsyear1] = date("Y") ;
	$ckapi[params_post][dt][tsmonth0] = $ckapi[params_post][dt][tsmonth1] = date("m") ;
	$ckapi[params_post][dt][tsday0] = $ckapi[params_post][dt][tsday1] = date("d") ;
	}

//---- timesheet Validation Checks

    function timesheet_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$app = $ckapi[params][app] ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=exapi_lang("Error") ;
	$row = exapi_lang("Row") ;
	$lang_na = strtolower(exapi_lang('not_applicable')) ;
	$lang_leave = strtolower(exapi_lang('leave')) ;
	$result = $adodb->query("SELECT * FROM ${pre}achievement WHERE name='$lang_na'");
	$achinaid = exapi_dbflds($result,'id');
	$leavecodes = selectlist('category','name',"WHERE app='$app' and type='$lang_leave'",'','name','name') ;
	$hour_ttl = 0 ;
	For ($i=1;isset($dt['tsyear'.$i]);$i++) {
		$rowi = "[$row $i] " ;
		$tsyear = $dt['tsyear'.$i] ;
		$tsmonth = $dt['tsmonth'.$i] ;
		$tsday = $dt['tsday'.$i] ;
		$date = input2date("$tsyear-$tsmonth-$tsday") ;
		$activity = $dt['activity'.$i] ;
		$hour = $dt['hour'.$i] ;
		$day = $dt['day'.$i] ;
		if ($date=="")			$err=$rowi.exapi_lang("Invalid Date");
		$dateweek = date('W',mktime(0,0,0,$tsmonth,$tsday,$tsyear)) ;
		if ($dateweek<>$dt[week])	$err=$rowi.exapi_lang("Date not compatible to Week");
		if ($activity=='')		$err=$rowi.exapi_lang("Invalid Activity") ;
		   else	if (substr_count($leavecodes,$dt['activity'.$i])==0)	{
				if (!is_numeric($hour) or $hour<=0 or $hour>24)
						$err=$rowi.exapi_lang("Invalid Hour") ;
				if ($day<>0)	$err=$rowi.exapi_lang("Invalid Day") ;
				}
		   	else {
				if ($hour<>0)	$err=$rowi.exapi_lang("Invalid Hour") ;
				if ($day==0)	$err=$rowi.exapi_lang("Invalid Day") ;
		   		}
		$hour_ttl += $hour ;
		$day_ttl += $day ;
		if ($dt['achival'.$i]=='' and $dt['achiunit'.$i]=='' and $dt['achieve'.$i]<>$achinaid)
			$err=$rowi.exapi_lang("Since Achievement<>not_applicable, value or unit must be non-blank");
		if ($day==0)	continue ;
		if ($dt[id]=='')	$dt[id] = 0 ;
		$sql =	"SELECT * FROM ${pre}leave WHERE leavefrom<='$date' and leaveto>='$date' " ;
		$sql.=				"and empid='$dt[empid]' and trans_id<>'$dt[id]'" ;
		$result = $adodb->query($sql);
		if (exapi_dbrc($result)>0)
			$err=$rowi.exapi_lang("Leave day falls within period(s) included in existing leave record");
		}
	if ($hour_ttl<>$dt[hour_ttl])		$err=exapi_lang("Invalid Total Hours") ;
	if ($day_ttl<>$dt[day_ttl])		$err=exapi_lang("Invalid Total Days") ;
	$sql = "SELECT * FROM ${pre}timesheet WHERE empid='$dt[empid]' and year='$dt[year]' and week='$dt[week]'" ;
	$result = $adodb->query($sql);
	if (exapi_dbrc($result)<>0 and exapi_dbflds($result,'id')<>$dt[id])
				$err=exapi_lang("Timesheet for the specified week already exist") ;
	
	$user = $ckapi[hostsys][username];
	$err1 = exapi_lang("Such address is needed to despatch email requesting timesheet approval") ;	
	$sql = "SELECT * FROM ${pre}comm a, ${pre}empperson b " ;
	$sql.= "WHERE contactid=b.id and username='$user' and commcode='wemail'" ;
	$result = $adodb->query($sql);
	if (exapi_dbrc($result)==0)	{
		$err0 = exapi_lang("You don't have a wemail (working email address) on record") ;
		$err = "$err0.  $err1." ;
		}
	$sql = "SELECT * FROM ${pre}comm a, ${pre}empperson b, ${pre}employee c " ;
	$sql.= "WHERE a.contactid=b.id and c.contactid=b.id and c.id='$dt[empid]' and commcode='wemail'" ;
	$result = $adodb->query($sql);
	if (exapi_dbrc($result)==0)	{
		$err0 = exapi_lang("Timesheet employee don't have a wemail (working email address) on record") ;
		$err = "$err0.  $err1." ;
		}
	$result = $adodb->query("SELECT * FROM ${pre}employee WHERE id='$dt[empid]'");
	$superid = exapi_dbflds($result,'supervisor');
	$sql = "SELECT * FROM ${pre}comm a, ${pre}empperson b, ${pre}employee c " ;
	$sql.= "WHERE a.contactid=b.id and c.contactid=b.id and c.id='$superid' and commcode='wemail'" ;
	$result = $adodb->query($sql);
	if (exapi_dbrc($result)==0)	{
		$err0 = exapi_lang("Timesheet employee's supervisor don't have a wemail (working email address) on record") ;
		$err = "$err0.  $err1." ;
		}

	if ($err)		$err="<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Timesheet Header

    function timesheet_header_write() {
	global $ckapi ;

	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	$t->set_var('lang_empid',exapi_lang('Employee'));
	$t->set_var('lang_id',exapi_lang('Audit ID').' :');
	$t->set_var('lang_year',exapi_lang('Year'));
	$t->set_var('lang_week',exapi_lang('Week'));
	$t->set_var('lang_approved_by',exapi_lang('Approved By'));
	$user = $ckapi[hostsys][username];
	$where = (!$uniwhere) ? " WHERE id='$dt[empid]' " : $uniwhere;
	$t->set_var('empid_selectlist',selectlist('employee','name',$where,$dt[empid],'id','name','id')) ;
	$t->set_var('year_selectlist',ymwd_selectlist('',$dt[year],'y')) ;
	$t->set_var('week_selectlist',ymwd_selectlist('',$dt[week],'w')) ;
	$t->set_var('approved_by',$dt[approved_by]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->parse('out','report',True);
	}

//---- Reformat Timesheet Array

    function timesheet_transform() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	if (isset($ckapi[buttons][replicate])) {
		For ($i=1;isset($dt['tsyear'.$i]);$i++) {
			$dt['tsyear'.$i]	=	$dt['tsyear0'] ;
			$dt['tsmonth'.$i]	=	$dt['tsmonth0'] ;
			$dt['tsday'.$i]		=	$dt['tsday0'] ;
			}
		}
	}

//---- Write Timesheet Detail

    function timesheet_detail_write() {
	global $ckapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	$row_ = exapi_lang('Row')." " ;
	$lang_activity = exapi_lang('activity') ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_transdate',exapi_lang('Date'));
	$t->set_var('lang_pah',exapi_lang('Project---Activity/Leave---Hours---Days'));
	$t->set_var('lang_achievement',exapi_lang('Result Achieved'));
	$t->set_var('lang_insert',exapi_lang('Insert<br>before'));
	$t->set_var('lang_tsyear',exapi_lang('Year'));
	$t->set_var('lang_tsmonth',exapi_lang('Month'));
	$t->set_var('lang_tsday',exapi_lang('Day'));
	$t->set_var('lang_project',exapi_lang('Project'));
	$t->set_var('lang_activity',exapi_lang('Activity/Leave'));
	$t->set_var('lang_hour',exapi_lang('Hour Worked'));
	$t->set_var('lang_day',exapi_lang('Days On Leave'));
	$t->set_var('lang_achieve',exapi_lang('Achievement'));
	$t->set_var('lang_achival',exapi_lang('Value'));
	$t->set_var('lang_achiunit',exapi_lang('Unit'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('tsyear0_selectlist',ymwd_selectlist('',$dt[tsyear0],'y')) ;
	$t->set_var('tsmonth0_selectlist',ymwd_selectlist('',$dt[tsmonth0],'m')) ;
	$t->set_var('tsday0_selectlist',ymwd_selectlist('',$dt[tsday0],'d')) ;

	$lang_leave = exapi_lang('leave') ;
	$nullopt = "<OPTION value=''></OPTION>" ;
	$act_sl = selectlist('category','name',"WHERE app='$app' and type='$lang_activity'",'','name','name','substring(description,1,25)') ;
	$act_sl.= $nullopt ;
	$act_sl.= "<OPTION value=''>".exapi_lang('On Leave (Pls enter -0- as hours worked)')."</OPTION>" ;
	$act_sl.= selectlist('category','name',"WHERE app='$app' and type='$lang_leave'",'','name','name','substring(description,1,25)') ;
	$lang_day = exapi_lang('day') ;
	$day_sl = $nullopt."<OPTION value='1'>1 $lang_day</OPTION><OPTION value='0.5'>0.5 $lang_day</OPTION>" ;
	$hour_ttl = 0;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['tsyear'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('tsyear_fld','tsyear'.$i) ;
			$t->set_var('tsmonth_fld','tsmonth'.$i) ;
			$t->set_var('tsday_fld','tsday'.$i) ;
			$t->set_var('project_fld','project'.$i) ;
			$t->set_var('activity_fld','activity'.$i) ;
			$t->set_var('hour_fld','hour'.$i) ;
			$t->set_var('day_fld','day'.$i) ;
			$t->set_var('achieve_fld','achieve'.$i);
			$t->set_var('achival_fld','achival'.$i);
			$t->set_var('achiunit_fld','achiunit'.$i);
			$t->set_var('tsyear_selectlist',ymwd_selectlist('',$dt['tsyear'.$i],'y'));
			$t->set_var('tsmonth_selectlist',ymwd_selectlist('',$dt['tsmonth'.$i],'m'));
			$t->set_var('tsday_selectlist',ymwd_selectlist('',$dt['tsday'.$i],'d')) ;
			$t->set_var('project_selectlist',$nullopt.selectlist('project','name','','','id','name')) ;
			$t->set_var('activity_selectlist',$act_sl);
			$t->set_var('hour','') ;
			$t->set_var('day_selectlist',$day_sl);
			$t->set_var('achieve_selectlist',selectlist('achievement','name','','','id','name')) ;
			$t->set_var('achival','') ;
			$t->set_var('achiunit','') ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$t->set_var('tsyear_fld','tsyear'.$j) ;
		$t->set_var('tsmonth_fld','tsmonth'.$j) ;
		$t->set_var('tsday_fld','tsday'.$j) ;
		$t->set_var('project_fld','project'.$j) ;
		$t->set_var('activity_fld','activity'.$j) ;
		$t->set_var('hour_fld','hour'.$j) ;
		$t->set_var('day_fld','day'.$j) ;
		$t->set_var('achieve_fld','achieve'.$j);
		$t->set_var('achival_fld','achival'.$j);
		$t->set_var('achiunit_fld','achiunit'.$j);
		$t->set_var('tsyear_selectlist',ymwd_selectlist('',$dt['tsyear'.$i],'y')) ;
		$t->set_var('tsmonth_selectlist',ymwd_selectlist('',$dt['tsmonth'.$i],'m')) ;
		$t->set_var('tsday_selectlist',ymwd_selectlist('',$dt['tsday'.$i],'d')) ;
		$t->set_var('project_selectlist',$nullopt.selectlist('project','name','',$dt['project'.$i],'id','name')) ;
		$default = $dt['activity'.$i] ;
		$t->set_var('activity_selectlist',str_replace("'$default'","'$default' selected",$act_sl)) ;
		$t->set_var('hour',$dt['hour'.$i]) ;
		$default = $dt['day'.$i] ;
		$t->set_var('day_selectlist',str_replace("'$default'","'$default' selected",$day_sl)) ;
		$t->set_var('achieve_selectlist',selectlist('achievement','name','',$dt['achieve'.$i],'id','name')) ;
		$t->set_var('achival',$dt['achival'.$i]) ;
		$t->set_var('achiunit',$dt['achiunit'.$i]) ;
		if ($posted)	$t->set_var('insrowno',"done") ; else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ; else	$t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==2 and $delrowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('tsyear_fld','tsyear'.$i) ;
		$t->set_var('tsmonth_fld','tsmonth'.$i) ;
		$t->set_var('tsday_fld','tsday'.$i) ;
		$t->set_var('project_fld','project'.$i) ;
		$t->set_var('activity_fld','activity'.$i) ;
		$t->set_var('hour_fld','hour'.$i) ;
		$t->set_var('day_fld','day'.$i) ;
		$t->set_var('achieve_fld','achieve'.$i);
		$t->set_var('achival_fld','achival'.$i);
		$t->set_var('achiunit_fld','achiunit'.$i);
		$t->set_var('project_selectlist',$nullopt.selectlist('project','name','','','id','name')) ;
		$t->set_var('activity_selectlist',$act_sl) ;
		$t->set_var('hour','') ;
		$t->set_var('day_selectlist',$day_sl) ;
		$t->set_var('achieve_selectlist',selectlist('achievement','name','','','id','name')) ;
		$t->set_var('achival','') ;
		$t->set_var('achiunit','') ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_total',exapi_lang('Total'));
	$t->set_var('hour_ttl',$dt[hour_ttl]) ;
	$t->set_var('day_ttl',$dt[day_ttl]) ;

	$t->parse('out','report',True);
	}

//---- Timesheet Post - PreCommit Routine

    function timesheet_post_precommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	if ($op<>'new') {
		$adodb->query("DELETE FROM ${pre}ts_trans where trans_id='$id'");
		$adodb->query("DELETE FROM ${pre}leave where trans_id='$id'");
		}
	if ($op<>'delete') {
		For ($i=1;isset($dt['tsyear'.$i]);$i++) {
			$transdate	= $dt['tsyear'.$i]."-".$dt['tsmonth'.$i]."-".$dt['tsday'.$i];
			$project	= ($dt['project'.$i]=="") ? 0 : $dt['project'.$i] ;
			$activity	= $dt['activity'.$i] ;
			$hour		= $dt['hour'.$i] ;
			$day		= $dt['day'.$i] ;
			$achieve	= $dt['achieve'.$i] ;
			$achival	= $dt['achival'.$i] ;
			$achiunit	= $dt['achiunit'.$i] ;
			$sql = "INSERT INTO ${pre}ts_trans " ;
			$sql.= "(trans_id,transdate,project,activity,hour," ;
			$sql.=		"day,achieve,achival,achiunit) " ;
			$sql.= "VALUES ('$id','$transdate','$project','$activity','$hour'," ;
			$sql.=		"'$day','$achieve','$achival','$achiunit')" ;
			$adodb->query($sql);
			if ($dt['day'.$i]==0)	continue ;
			$sql ="INSERT INTO ${pre}leave(empid,trans_id,leavefrom,leaveto,leavecode,duration) ";
			$sql.= "VALUES ('$dt[empid]','$id','$transdate','$transdate','$activity','$day')" ;
			$adodb->query($sql);
			}
		}
	}

//---- Timesheet Post - PostCommit Routine

    function timesheet_post_postcommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$actioned = $ckapi[phrases][actioned] ;

	$year = $dt[year] ;
	$week = $dt[week] ;
	
	$user = $ckapi[hostsys][username];
	$sql = "SELECT a.*,prsnumber as name FROM ${pre}comm a, ${pre}empperson b " ;
	$sql.= "WHERE contactid=b.id and username='$user' and commcode='wemail'" ;
	$result = $adodb->query($sql);
	$hrstaffname = exapi_dbflds($result,'name');
	$hrstaffemail = exapi_dbflds($result,'commdata') ;
	
	$sql = "SELECT a.*,prsnumber as name FROM ${pre}comm a, ${pre}empperson b, ${pre}employee c " ;
	$sql.= "WHERE a.contactid=b.id and c.contactid=b.id and c.id='$dt[empid]' and commcode='wemail'" ;
	$result = $adodb->query($sql);
	$staffname = exapi_dbflds($result,'name');
	$staffemail = exapi_dbflds($result,'commdata') ;
	
	$result = $adodb->query("SELECT * FROM ${pre}employee WHERE id='$dt[empid]'");
	$superid = exapi_dbflds($result,'supervisor');
	$sql = "SELECT a.*,prsnumber as name FROM ${pre}comm a, ${pre}empperson b, ${pre}employee c " ;
	$sql.= "WHERE a.contactid=b.id and c.contactid=b.id and c.id='$superid' and commcode='wemail'" ;
	$result = $adodb->query($sql);
	$supername = exapi_dbflds($result,'name');
	$superemail = exapi_dbflds($result,'commdata') ;
	
	$recipient = "$staffname < $staffemail >" ;
	$subject = exapi_lang("%1's Timesheet [YEAR:%2 WEEK:%3] %4 by HR Staff",$staffname,$year,$week,$actioned) ;
	$message = '' ;
	$headers = "From: $hrstaffname < $hrstaffemail > \n" ;
	$charset = exapi_lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $hrstaffname < $hrstaffemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	$successmsg = exapi_lang("Email advising action on %1's Timesheet [YEAR:%2 WEEK:%3] successfully queued for despatch to",$staffname,$year,$week) ;
	$failuremsg = exapi_lang("Email advising action on %1's Timesheet [YEAR:%2 WEEK:%3] fails to deliver.  Please manually inform",$staffname,$year,$week) ;
	$lang_staff = exapi_lang("Staff:") ;
	if ($result)	$msg = "$msg<br>$lang_staff $successmsg $staffname." ;
		else	$msg = "$msg<br>$lang_staff $failuremsg $staffname." ;
	$recipient = "$supername < $superemail >" ;
	$lang_super = exapi_lang("Supervisor:") ;
	$result= mail($recipient,$subject,$message,$headers) ;
	if ($result)	$msg = "$msg<br>$lang_super $successmsg $supername." ;
		else	$msg = "$msg<br>$lang_super $failuremsg $supername." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}

    }

?>
