<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.reductn.inc.php 0.15.1 2005/09/30 C K Wu

    class reductn {

//---- reductn Read

    function reductn_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$result = $adodb->query("SELECT * FROM ${pre}reductn WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$dt[desc] = exapi_dbflds($result,'description') ;

	$result = $adodb->query("SELECT * FROM ${pre}rdtnexem WHERE rdtnid='$id' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['eaid'.$i]		=	$rs['pyrcodeid'] ;
		$dt['exemmin'.$i]	=	$rs['min'] ;
		$dt['exemactmin'.$i]	=	$rs['actmin'] ;
		$dt['exemmax'.$i]	=	$rs['max'] ;
		$dt['exemactmax'.$i]	=	$rs['actmax'] ;
		}
	$result = $adodb->query("SELECT * FROM ${pre}rdtnrate WHERE rdtnid='$id' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['step'.$i]		=	$rs['step'] ;
		$dt['rate'.$i]		=	$rs['rate'] ;
		$dt['subtract'.$i]	=	$rs['subtract'] ;
		}
	if (is_array($uniqueflds) and $op=='edit')
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- reductn Validation Checks

    function reductn_validate() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error = exapi_lang("Error") ;
	$exem = exapi_lang("ExemptItem") ;
	$ratetbl = exapi_lang("Rate Table") ;
	$row = exapi_lang("Row") ;
	if ($dt[name]<>$dt[oldname]) {
		$result = $adodb->query("SELECT * FROM $table where name='$dt[name]'");
		if (exapi_dbrc($result)>0)	$err=exapi_lang("Summary Level Reduction Name already in use") ;
		}
	if ($dt[name]=='')		$err=exapi_lang("Reduction Name Missing");
	if ($dt[desc]=='')		$err=exapi_lang("Reduction Description Missing");
	if ($dt[locality]=='')		$err=exapi_lang("Locality Missing");
	if ($dt[chart_id]=='')		$err=exapi_lang("Payroll Reduction Account Missing") ;
	if ($dt[floor]=='')		$err=exapi_lang("Reduction Floor Value Missing");
	if (!is_numeric($dt[floor]))	$err=exapi_lang("Reduction Floor Value must be numeric") ;
	if ($dt[min]=='')		$err=exapi_lang("Reduction Minimum Value Missing");
	if ($dt[max]=='')		$err=exapi_lang("Reduction Maximum Value Missing");
	if ($dt[min]>$dt[max])		$err=exapi_lang("Reduction Minimum > Maximum") ;
	if (!is_numeric($dt[min]))	$err=exapi_lang("Reduction Minimum Value must be numeric") ;
	if (!is_numeric($dt[max]))	$err=exapi_lang("Reduction Maximum Value must be numeric") ;
	For ($i=1;isset($dt['eaid'.$i]);$i++) {
		$rowi = "[$exem $row $i]" ;
		$min = $dt['exemmin'.$i] ;
		$max = $dt['exemmax'.$i] ;
		if ($dt['eaid'.$i]=='')	$err=$rowi.exapi_lang("Allowance/Deduction Code Missing") ;
		if ($min=='')		$err=$rowi.exapi_lang("ExemptItem Minimum Value Missing");
		if ($max=='')		$err=$rowi.exapi_lang("ExemptItem Maximum Value Missing");
		if ($min>$max)		$err=$rowi.exapi_lang("ExemptItem Minimum > Maximum") ;
		if (!is_numeric($min))	$err=$rowi.exapi_lang("ExemptItem Minimum Value must be numeric");
		if (!is_numeric($max))	$err=$rowi.exapi_lang("ExemptItem Maximum Value must be numeric");
		}
	if (isset($dt[step1]))		$laststep = $dt[step1] ;
	For ($i=1;isset($dt['step'.$i]);$i++) {
		$rowi = "[$ratetbl $row $i]" ;
		$step = $dt['step'.$i] ;
		if ($step=='')			$err=$rowi.exapi_lang("Step Value Missing") ;
		if ($step<0)			$err=$rowi.exapi_lang("Step Value must be +ve") ;
		if (!is_numeric($step))		$err=$rowi.exapi_lang("Step Value must be numeric");
		if ($dt['rate'.$i]=='')		$err=$rowi.exapi_lang("Rate Value Missing") ;
		if ($dt['rate'.$i]<0)		$err=$rowi.exapi_lang("Rate Value must be +ve") ;
		if (!is_numeric($dt['rate'.$i])) $err=$rowi.exapi_lang("Rate Value must be numeric");
		if ($dt['subtract'.$i]=='')	$err=$rowi.exapi_lang("Subtract Value Missing") ;
		if ($dt['subtract'.$i]<0)	$err=$rowi.exapi_lang("Subtract Value must be +ve") ;
		if (!is_numeric($dt['subtract'.$i])) $err=$rowi.exapi_lang("Subtract Value must be numeric");
		if ($i>1) {
			if ($step<=$laststep)	$err=$rowi.exapi_lang("Step Value must be strictly ascending") ;
			$laststep = $step ;
			}
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write reductn Header

    function reductn_header_write() {
	global $ckapi ;

	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_name',exapi_lang('Name'));
	$t->set_var('lang_id',exapi_lang('Audit ID').' :');
	$t->set_var('lang_desc',exapi_lang('Description'));
	$t->set_var('lang_locality',exapi_lang('Locality'));
	$t->set_var('lang_chart_id',exapi_lang('Payroll Expense/Liability Account'));
	$t->set_var('lang_floor',exapi_lang('Floor'));
	$t->set_var('lang_min',exapi_lang('Minimum'));
	$t->set_var('lang_actmin',exapi_lang('If < Min'));
	$t->set_var('lang_max',exapi_lang('Maximum'));
	$t->set_var('lang_actmax',exapi_lang('If > Max'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('name',$dt[name]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('desc',$dt[desc]) ;
	$t->set_var('locality',$dt[locality]) ;
	$account_sl = selectlist('chart','accno',"WHERE link like '%PY:%' or link like '%PY' or link like '%PY_expense%'",$dt[chart_id],'id','accno','description') ;
	$t->set_var('chart_id_selectlist',$account_sl) ;
	$t->set_var('floor',$dt[floor]) ;
	$threshold_sl = "<OPTION value='rej'>".exapi_lang('Reject')."</OPTION><OPTION value='lmt'>".exapi_lang('Set to Limit')."</OPTION>" ;
	$t->set_var('min',$dt[min]) ;
	$t->set_var('actmin_selectlist',str_replace("'$dt[actmin]'","'$dt[actmin]' selected",$threshold_sl)) ;
	$t->set_var('max',$dt[max]) ;
	$t->set_var('actmax_selectlist',str_replace("'$dt[actmax]'","'$dt[actmax]' selected",$threshold_sl)) ;
	$t->parse('out','report',True);
	}

//---- Write reductn Detail

    function reductn_detail_write() {
	global $ckapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_block('report','exem','exem_section');
	$t->set_block('report','ratetbl','rate_section');

	$row_ = exapi_lang('Row')." " ;
	$exrow_ = exapi_lang('exRow')." " ;
	$rtrow_ = exapi_lang('rtRow')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_exem',exapi_lang('Items to be excluded from PayrollTotal during Calculation (ExemptItem)'));
	$t->set_var('lang_eaid',exapi_lang("Allowance/Deduction"));
	$t->set_var('lang_exemmin',exapi_lang("Minimum"));
	$t->set_var('lang_exemactmin',exapi_lang('If < Min'));
	$t->set_var('lang_exemmax',exapi_lang("Maximum"));
	$t->set_var('lang_exemactmax',exapi_lang('If > Max'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	
	$eaid_sl = selectlist('pyrcode','name','','','id','name','id') ;
	$threshold_sl = "<OPTION value='rej'>".exapi_lang('Reject')."</OPTION><OPTION value='lmt'>".exapi_lang('Set to Limit')."</OPTION>" ;
	if (isset($delete))	$delrowno = intval(str_replace($exrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($dt['eaid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		$j = $i ;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$t->set_var('eaid_fld','eaid'.$j) ;
		$t->set_var('exemmin_fld','exemmin'.$j) ;
		$t->set_var('exemactmin_fld','exemactmin'.$j) ;
		$t->set_var('exemmax_fld','exemmax'.$j) ;
		$t->set_var('exemactmax_fld','exemactmax'.$j) ;
		$eaid = $dt['eaid'.$i] ;
		$t->set_var('eaid_selectlist',str_replace("'$eaid'","'$eaid' selected",$eaid_sl)) ;
		$t->set_var('exemmin',$dt['exemmin'.$i]) ;
		$actmin = $dt['exemactmin'.$i] ;
		$t->set_var('exemactmin_selectlist',str_replace("'$actmin'","'$actmin' selected",$threshold_sl)) ;
		$t->set_var('exemmax',$dt['exemmax'.$i]) ;
		$actmax = $dt['exemactmax'.$i] ;
		$t->set_var('exemactmax_selectlist',str_replace("'$actmax'","'$actmax' selected",$threshold_sl)) ;

		if ($posted)	$t->set_var('exdelrowno',"done") ;
			else	$t->set_var('exdelrowno',$exrow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('exem_section','exem', True);
		}
	if ($i==1)			$t->set_var('exem_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('exem_section','') ;
	if ($newrow==exapi_lang('Add New ExemptItem Row')) {
		$t->set_var('eaid_fld','eaid'.$i) ;
		$t->set_var('exemmin_fld','exemmin'.$i) ;
		$t->set_var('exemactmin_fld','exemactmin'.$i) ;
		$t->set_var('exemmax_fld','exemmax'.$i) ;
		$t->set_var('exemactmax_fld','exemactmax'.$i) ;
		$t->set_var('eaid_selectlist',$eaid_sl) ;
		$t->set_var('exemmin','') ;
		$t->set_var('exemactmin_selectlist',$threshold_sl) ;
		$t->set_var('exemmax','') ;
		$t->set_var('exemactmax_selectlist',$threshold_sl) ;
		$t->set_var('exdelrowno',$exrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('exem_section','exem', True);
		}

	$t->set_var('lang_ratetbl',exapi_lang('(Progressive) Reduction/Tax Rate Table'));
	$t->set_var('lang_insert',exapi_lang('Insert before'));
	$t->set_var('lang_floor',exapi_lang("Floor"));
	$t->set_var('lang_step',exapi_lang("Step"));
	$t->set_var('lang_rate',exapi_lang("Rate"));
	$t->set_var('lang_subtract',exapi_lang("Subtract"));
	$t->set_var('lang_ratemin',exapi_lang("Minimum"));
	$t->set_var('lang_ratemax',exapi_lang("Maximum"));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($rtrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($dt['step'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('step_fld','step'.$i) ;
			$t->set_var('rate_fld','rate'.$i) ;
			$t->set_var('subtract_fld','subtract'.$i) ;
			$t->set_var('step','') ;
			$t->set_var('rate','') ;
			$t->set_var('subtract','') ;
			$t->set_var('rtdelrowno',$rtrow_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('rate_section','ratetbl', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$t->set_var('step_fld','step'.$j) ;
		$t->set_var('rate_fld','rate'.$j) ;
		$t->set_var('subtract_fld','subtract'.$j) ;
		$t->set_var('step',$dt['step'.$i]) ;
		$t->set_var('rate',$dt['rate'.$i]) ;
		$t->set_var('subtract',$dt['subtract'.$i]) ;

		if ($posted)	$t->set_var('insrowno',"done") ; else $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('rtdelrowno',"done") ; else $t->set_var('rtdelrowno',$rtrow_.$j);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('rate_section','ratetbl', True);
		}
	if ($i==1)			$t->set_var('rate_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('rate_section','') ;
	if ($newrow==exapi_lang('Add New Rate Table Row')) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('step_fld','step'.$i) ;
		$t->set_var('rate_fld','rate'.$i) ;
		$t->set_var('subtract_fld','subtract'.$i) ;
		$t->set_var('step','') ;
		$t->set_var('rate','') ;
		$t->set_var('subtract','') ;
		$t->set_var('rtdelrowno',$rtrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('rate_section','ratetbl', True);
		}

	$t->parse('out','report',True);
	}

//---- Reductn Post Initialisation

    function reductn_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][description] = $ckapi[params_post][dt][desc] ;
	}

//---- Reductn Post - PreCommit Routine

    function reductn_post_precommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')	{
		$adodb->query("DELETE from ${pre}rdtnexem where rdtnid='$id'");
		$adodb->query("DELETE from ${pre}rdtnrate where rdtnid='$id'");
		}
	if ($op<>'delete') {
		For ($i=1;isset($dt['eaid'.$i]);$i++) {
			$eaid		=	$dt['eaid'.$i];
			$exemmin	=	$dt['exemmin'.$i] ;
			$exemactmin	=	$dt['exemactmin'.$i] ;
			$exemmax	=	$dt['exemmax'.$i] ;
			$exemactmax	=	$dt['exemactmax'.$i] ;
			$sql = "INSERT INTO {$pre}rdtnexem (rdtnid,pyrcodeid,min,actmin,max,actmax)" ;
			$sql.=	"VALUES ('$id','$eaid','$exemmin','$exemactmin','$exemmax','$exemactmax')" ;
			$adodb->query($sql);
			}
		For ($i=1;isset($dt['step'.$i]);$i++) {
			$step		=	$dt['step'.$i];
			$rate		=	$dt['rate'.$i] ;
			$subtract	=	$dt['subtract'.$i] ;
			$sql = "INSERT INTO ${pre}rdtnrate (rdtnid,step,rate,subtract)" ;
			$sql.=	"VALUES ('$id','$step','$rate','$subtract')" ;
			$adodb->query($sql);
			}
		}
	}

    }

?>
