<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.cbtran.inc.php 0.15.1 2005/09/30 C K Wu

    class cbtran {

//---- CashBox List SQL Formation

    function cbtran_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$sql =  "SELECT cbtnumber,name,manager,a.cashier as cashier," ;
	$sql.=	"transdate,a.shift as shift,trantype,amount,a.id as id " ;
	$sql.=	"FROM ${pre}cbtran a, ${pre}cashbox b " ;
	$sql.=	"WHERE 1=1 $where and a.cboxid=b.id order by ".$order." ".$sort ;
	return $sql ;
	}

//---- CashBox Transaction Read

    function cbtran_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$result = $adodb->query("select * from $table where id='$id'");
	$dt = $result->fetchRow() ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}


//---- CashBox Transaction Detail Validation Checks

    function cbtran_validate() {
	global $ckapi,$adodb ;

	$table = $ckapi[params][table] ;
	$dt = $ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;

	$err=""; $error=exapi_lang('Error') ;
	$sos_completed = exapi_lang("Start-of-shift tran already completed") ;
	$eos_completed = exapi_lang("Cashbox closed (end-of-shift completed)") ;
	$sos_retry = exapi_lang("If necessary, delete current sos, then retry") ;
	$eos_retry = exapi_lang("If necessary, delete current eos, then retry") ;
	$cboxid = $dt[cboxid] ;
	$transdate = $dt[transdate] ;
	$shift = $dt[shift] ;
	$trantype = $dt[trantype] ;
	$amount = $dt[amount] ;
	if (!$dt[cbtnumber] or $dt[cbtnumber]=="")		$err=exapi_lang('CashBox Transaction Name missing');
		else	{
			$cbtnumber = addslashes($dt[cbtnumber]) ;
			$result = $adodb->query("SELECT * from $table WHERE cbtnumber='$cbtnumber'") ;
			if (exapi_dbrc($result)<>0 and $dt[cbtnumber]<>$dt[oldcbtnumber])
				$err=exapi_lang('CashBox Transaction name already in use');
			}
	if (input2date($transdate)=="")				$err=exapi_lang('Invalid Cash Sale Date');
	if (!$amount or $amount=="")				$err=exapi_lang('Transaction Amount missing');
	if (($trantype=="s" or $trantype=="+") and $amount<0)	$err=exapi_lang('s/+ trans must have +ve amount') ;
	if (($trantype=="e" or $trantype=="-") and $amount>0)	$err=exapi_lang('e/- trans must have -ve amount') ;
	if (!exapi_is_admin($ckapi[hostsys][username]))	$err=exapi_lang('Action restricted to admin level user');
	$sql = "SELECT * FROM $table WHERE cboxid='$cboxid' and " ;
	$sql.= "transdate='$transdate' and shift='$shift' and trantype='s'" ;
	$result = $adodb->query($sql) ;
	$exist = exapi_dbrc($result)>0 ;
	if ($trantype=='s' and $exist and $op<>'edit')		$err = "$sos_completed.  $sos_retry.";
	if ($trantype<>'s' and !$exist)				$err=exapi_lang("Start-of-shift tran pending");
	$sql = "SELECT * FROM $table WHERE cboxid='$cboxid' and " ;
	$sql.= "transdate='$transdate' and shift='$shift' and trantype='e'" ;
	$result = $adodb->query($sql) ;
	if (exapi_dbrc($result)>0 and $op<>'edit')	$err = "$eos_completed.  $eos_retry." ;
	$sql = "SELECT max(transdate) as lastdate FROM $table WHERE cboxid='$cboxid'" ;
	$result = $adodb->query($sql) ;
	$lastdate = exapi_dbflds($result,'lastdate') ;
	if ($lastdate<>'') {
		$sql = "SELECT max(shift) as lastshift FROM $table WHERE cboxid='$cboxid' and transdate='$lastdate'" ;
		$result = $adodb->query($sql) ;
		$lastshift = exapi_dbflds($result,'lastshift') ;
		if ($lastdate<>'' and $trantype=='s' and $lastdate<$transdate)	{
			$sql = "SELECT * from $table where cboxid='$cboxid' and " ;
			$sql.= "transdate='$lastdate' and shift='$lastshift' and trantype='e'" ;
			$result = $adodb->query($sql) ;
			$sshift = exapi_lang("shift") ;
			if (exapi_dbrc($result)<=0)
				$err=exapi_lang("Cashbox not closed on")." [$lastdate] $sshift [$lastshift]";
			}
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- CashBox Transaction Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$completed = exapi_lang("Cashbox closed (end-of-shift completed)") ;
	$retry = exapi_lang("If necessary, delete current eos, then retry") ;
	$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
	$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='e'" ;
	$result = $adodb->query($sql) ;
	if (exapi_dbrc($result)>0 and $dt[trantype]<>'e')	$err = "$completed.  $retry." ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write CashBox Transaction Detail

    function cbtran_write() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_cbtnumber',exapi_lang('CashBox Transaction #')."  ");
	$t->set_var('lang_id',exapi_lang('Audit ID').': ');
	$t->set_var('lang_cboxid',exapi_lang('Cash Box ID')."  ");
	$t->set_var('lang_manager',exapi_lang('Manager:'));
	$t->set_var('lang_cashier',exapi_lang('Cashier'));
	$t->set_var('lang_transdate',exapi_lang('Cash Sale Date'));
	$t->set_var('lang_shift',exapi_lang('Shift'));
	$t->set_var('lang_trantype',exapi_lang('Transaction Type'));
	$t->set_var('lang_amount',exapi_lang('Transaction Amount'));
	$t->set_var('lang_linkageaccount',exapi_lang("Link to Ledger Accounts"));
	$t->set_var('lang_poscashac',exapi_lang("Cash at Point of Sale"));
	$t->set_var('lang_citac',exapi_lang("Cash in transit"));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('cbtnumber',$dt[cbtnumber]) ;
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('cboxid',$dt[cboxid]);
	$t->set_var('cboxid_sl',selectlist('cashbox','name','',$dt[cboxid],'id','name','id'));
	$t->set_var('manager',$dt[manager]);
	$t->set_var('cashier',$dt[cashier]);
	$t->set_var('transdate',$dt[transdate]);
	$t->set_var('shift',$dt[shift]);
	$selectlist = "<OPTION value='1'>1 - ".exapi_lang('Morning')."</OPTION>" ;
	$selectlist.= "<OPTION value='2'>2 - ".exapi_lang('Afternoon')."</OPTION>" ;
	$selectlist.= "<OPTION value='3'>3 - ".exapi_lang('Overnight')."</OPTION>" ;
	$selectlist = str_replace("'$dt[shift]'","'$dt[shift]'"." selected",$selectlist) ;
	$t->set_var('shift_sl',$selectlist);
	$t->set_var('trantype',$dt[trantype]);
	$selectlist = "<OPTION value='s'>s - ".exapi_lang('Start-of-shift')."</OPTION>" ;
	$selectlist.= "<OPTION value='+'>+ => ".exapi_lang('Cash in')."</OPTION>" ;
	$selectlist.= "<OPTION value='-'>- => ".exapi_lang('Cash out')."</OPTION>" ;
	$selectlist.= "<OPTION value='e'>e - ".exapi_lang('End-of-shift')."</OPTION>" ;
	$selectlist = str_replace("'$dt[trantype]'","'$dt[trantype]'"." selected",$selectlist) ;
	$t->set_var('trantype_sl',$selectlist);
	$t->set_var('amount',$dt[amount]);
	$posac_sl = selectlist('chart','accno',"WHERE link like '%CS:%' or link like '%CS'",$dt[posac_id],'id','accno','description');
	$citac_sl = selectlist('chart','accno',"WHERE link like '%CS:%' or link like '%CS'",$dt[citac_id],'id','accno','description');
	$t->set_var('posac_sl',$posac_sl);
	$t->set_var('citac_sl',$citac_sl);

	$t->parse('out','report',True);
	}

//---- CashBox Transaction Post Initialisation

    function cbtran_post_init() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$dt[source]	= "CBTR" ;
	$dt[description]= "CB: Cashbox Tran# $dt[cbtnumber]";
	
	$cboxid = $dt[cboxid] ;
	$transdate = $dt[transdate] ;
	$shift = $dt[shift] ;
	$sql =	"SELECT sum(qty*a.value) as amount FROM ${pre}positem a, ${pre}pos b, ${pre}qcash c " ;
	$sql.=	"WHERE cboxid='$cboxid' and transdate='$transdate' and shift='$shift' and " ;
	$sql.=		"name='Cash' and a.trans_id=b.id and a.itemid=c.id GROUP BY itemid" ;
	$result = $adodb->query($sql);
	$amount = exapi_dbflds($result,'amount');
	$sql =	"SELECT sum(qty*value) as amount FROM ${pre}positem a, ${pre}pos b " ;
	$sql.=	"WHERE cboxid='$cboxid' and transdate='$transdate' and shift='$shift' and " ;
	$sql.=		"itemtype='c' and a.trans_id=b.id GROUP BY itemid" ;
	$result = $adodb->query($sql);
	$amount+= exapi_dbflds($result,'amount');
	$sql =	"SELECT sum(amount) as amount from ${pre}cbtran " ;
	$sql.=	"WHERE cboxid='$cboxid' and transdate='$transdate' and shift='$shift'" ;
	$result = $adodb->query($sql);
	$amount+= exapi_dbflds($result,'amount');
	$dt[netbal] = number_format($amount,2,".",'') ;
	}

//---- CashBox Transaction Post - PreCommit Routine

    function cbtran_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = $ckapi[params_post][dt] ;

	if ($op<>'new')		$adodb->query("DELETE from ${pre}acc_trans where trans_id='$id'");
	if ($op<>'delete') {
		$posac_id = $dt[posac_id] ;
		$transdate = $dt[transdate] ;
		$amount = $dt[amount] ;
		$negamount = -$dt[amount] ;
		$sql1 = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) " ;
		$adodb->query("$sql1 VALUES ('$id','$posac_id','$negamount','$transdate')");
		$adodb->query("$sql1 VALUES ('$id','$dt[citac_id]','$amount','$transdate')");
		if ($dt[trantype]=='e') {
			$netbal = $dt[netbal] + $amount;
			$negnetbal = -$netbal ;
			if ($netbal<>0)	{
				$lang_misexp = exapi_lang('Miscellaneous Expense') ;
				$sql = "SELECT id from ${pre}chart WHERE lower(description) like lower('%$lang_misexp%')" ;
				$result = $adodb->query($sql);
				$misexp = exapi_dbflds($result,'id') ;
				$adodb->query("$sql1 VALUES ('$id','$posac_id','$netbal','$transdate')");
				$adodb->query("$sql1 VALUES ('$id','$misexp','$negnetbal','$transdate')");
				}
			}
		}
	}

    }

?>
